# Summary
 
NESTracer allows you to enjoy Nintendo Family Computer (NES) games just like a typical emulator, but its main purpose is as a tracer that tracks the internal processing of the Family Computer hardware and software.
 
All processing (MOS6502, PPU, APU) is coded in VisualStadio's c# language and .net, making it easy to understand the internal processing of the hardware.
 
The software also displays MOS6502 programs in disassembled form, allowing you to stop them at any point and check the values ​​of memory, registers, etc. while stepping through the program.
 
Enjoy the amazing technology and wisdom of the engineers of the time from both the hardware and software perspectives.
 
Note: This program is not intended for playing games illegally. Its purpose is to help users understand and appreciate the ingenuity of the engineers who created this remarkable technology.
 
![demo1](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu1.png)

 
* This program provides the following features
 * Draws a virtual screen and allows you to check the contents
 * Displays the program in assembler and allows you to stop it at any point
 * Displays the values ​​of the MOS6502 and PPU registers
 * Searches for the places where the MOS6502 accesses the PPU or APU
 * Can stop at the point where specified memory is referenced/updated


* This program is entirely written in C# and .NET.
* It can be compiled using Visual Studio 2022.
![demo2](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu2.png)
![demo3](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu3.png)
![demo4](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu4.png)
![demo5](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu5.png)
![demo6](https://www.jppass.com/nestracer/wp-content/uploads/2025/01/menu6.png)

## page
  https://www.jppass.com/nestracer
  
## binary
  https://www.jppass.com/nestracer/download/
  
## source
  GitHub: https://github.com/sasayaki-japan/NESTracer/tree/main
  
## Compatibility
This tracer only supports mapper 0/1/2/3/4/21

## License  
This project is licensed under the MIT License. 
Copyright (c) 2019 Stephane Dallongeville
